"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PlantLink = void 0;
const tslib_1 = require("tslib");
const lodash_snakecase_1 = tslib_1.__importDefault(require("lodash.snakecase"));
class PlantLink {
    from;
    to;
    label;
    style;
    constructor(from, to, label, style = 'solid') {
        this.from = from;
        this.to = to;
        this.label = label;
        this.style = style;
    }
    toString() {
        const arrow = this.style === 'solid' ? '-->' : '..>';
        const from = (0, lodash_snakecase_1.default)(this.from);
        const to = (0, lodash_snakecase_1.default)(this.to);
        const label = this.label ? `: ${this.label}` : '';
        return `${from} ${arrow} ${to} ${label}`;
    }
}
exports.PlantLink = PlantLink;
//# sourceMappingURL=PlantLink.js.map