"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sendAsyncMessage = void 0;
function sendAsyncMessage(connection, eventName, payload) {
    return new Promise((resolve, reject) => {
        function onError(err) {
            connection.off('error', onError);
            connection.off(`${eventName}Done`, onDone);
            reject(err);
        }
        function onDone(response) {
            connection.off(`${eventName}Done`, onDone);
            connection.off('error', onError);
            resolve(response);
        }
        connection.on('error', onError).on(`${eventName}Done`, onDone).emit(eventName, payload);
    });
}
exports.sendAsyncMessage = sendAsyncMessage;
//# sourceMappingURL=sendAsyncMessage.js.map