import type { MetadataChecker } from '../checker';
import type { BaseMetadata, DescribeBlockMetadata, HookDefinitionMetadata, HookInvocationMetadata, TestFileMetadata, TestEntryMetadata, TestFnInvocationMetadata, TestInvocationMetadata } from '../containers';
import type { MetadataSelector } from './MetadataSelector';
export declare class MetadataSelectorImpl implements MetadataSelector {
    readonly check: MetadataChecker;
    readonly value: () => BaseMetadata | undefined;
    constructor(check: MetadataChecker, value: () => BaseMetadata | undefined);
    get file(): TestFileMetadata | undefined;
    get describeBlock(): DescribeBlockMetadata | undefined;
    get testEntry(): TestEntryMetadata | undefined;
    get hookDefinition(): HookDefinitionMetadata | undefined;
    get definition(): DescribeBlockMetadata | HookDefinitionMetadata | TestEntryMetadata | undefined;
    get testFnInvocation(): TestFnInvocationMetadata | undefined;
    get hookInvocation(): HookInvocationMetadata | undefined;
    get testInvocation(): TestInvocationMetadata | undefined;
    get invocationParent(): TestInvocationMetadata | DescribeBlockMetadata | undefined;
    get invocation(): TestFileMetadata | DescribeBlockMetadata | HookInvocationMetadata | TestInvocationMetadata | TestFnInvocationMetadata | undefined;
}
