"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseRealm = void 0;
const jest_environment_1 = require("../jest-environment");
const jest_reporter_1 = require("../jest-reporter");
const metadata_1 = require("../metadata");
const utils_1 = require("../utils");
class BaseRealm {
    coreEmitter = new utils_1.SerialEmitter('core').on('*', (event) => {
        this.metadataHandler.handle(event);
    });
    setEmitter = new utils_1.SerialEmitter('set');
    events = new utils_1.AggregatedEmitter('events').add(this.coreEmitter);
    metadataRegistry = new metadata_1.GlobalMetadataRegistry();
    metadataFactory = new metadata_1.MetadataFactoryImpl(this.metadataRegistry, this.setEmitter);
    globalMetadata = this.metadataFactory.createGlobalMetadata();
    environmentHandler = new jest_environment_1.EnvironmentEventHandler({
        emitter: this.coreEmitter,
    });
    metadataHandler = new metadata_1.MetadataEventHandler({
        globalMetadata: this.globalMetadata,
        metadataRegistry: this.metadataRegistry,
    });
    metadataDSL = new metadata_1.MetadataDSL(this.coreEmitter, () => this.globalMetadata.currentMetadata);
    associate = new jest_reporter_1.AssociateMetadata();
    query = new jest_reporter_1.QueryMetadata(this.associate, this.metadataFactory.checker);
}
exports.BaseRealm = BaseRealm;
//# sourceMappingURL=BaseRealm.js.map