"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChildProcessRealm = void 0;
const ipc_1 = require("../ipc");
const jest_environment_1 = require("../jest-environment");
const utils_1 = require("../utils");
const BaseRealm_1 = require("./BaseRealm");
const detect_1 = require("./detect");
class ChildProcessRealm extends BaseRealm_1.BaseRealm {
    type = 'child_process';
    environmentHandler = new jest_environment_1.EnvironmentEventHandler({
        emitter: this.coreEmitter,
    });
    ipc = new ipc_1.IPCClient({
        appspace: `jest-metadata@${(0, utils_1.getVersion)()}-`,
        serverId: (0, detect_1.getServerId)(),
        clientId: (0, detect_1.getClientId)(),
        globalMetadata: this.globalMetadata,
    });
    constructor() {
        super();
        this.events.on('*', (event) => {
            return this.ipc.enqueue(event);
        });
    }
}
exports.ChildProcessRealm = ChildProcessRealm;
//# sourceMappingURL=ChildProcessRealm.js.map